$source
'********************************************************************************
'* File:            EFC train optimizer.bas                                     *
'* Author:          Tito Livio Medeiros Cardoso                                 *
'* Project:         train-type Optimization for Carajas railroad (EFC)          *
'* State:           1.0                                                         *
'* Creation Date:   17/11/2003                                                  *
'* Description:     This program implements a simple GUI for entrance of        *
'*                  optimization parameters for routine with the objective of   *
'*                  to find the train configuration that minimizes the costs of *
'*                  HP, wagons, patios, teams and diesel. The used algorithm is *
'*                  of exhaustive research.                                     *
'* Revision Log:                                                                *
'*                  17/11/2003 1.00.00 - Initial development                    *
'********************************************************************************


'*********************************
'Definition of GUI and its events
'*********************************
GUI "OptimizeEFC", PIXELS, ICON, 123

'Definition of some varied that receive input in a SUB but they are processed in another
GLOBAL acopla_help  AS DOUBLE
GLOBAL espera_cruz  AS DOUBLE
GLOBAL custo_linha  AS DOUBLE
GLOBAL chk_terminal AS INTEGER


'---------------------------------------------------------------
SUB FORMLOAD()

    GLOBAL Form1 AS CONTROL

    GLOBAL Panel1 AS CONTROL
    GLOBAL Label1 AS CONTROL
    GLOBAL Label2 AS CONTROL
    GLOBAL Label3 AS CONTROL
    GLOBAL Label4 AS CONTROL
    GLOBAL Label5 AS CONTROL
    GLOBAL Label6 AS CONTROL
    GLOBAL Label7 AS CONTROL

    GLOBAL Retorno_menor AS CONTROL        'checkbox
    GLOBAL Rebocadas AS CONTROL            'checkbox
    GLOBAL Sem_patio_check AS CONTROL      'checkbox

    GLOBAL Text_min_tbhp AS CONTROL
    GLOBAL Text_min_locos AS CONTROL
    GLOBAL Text_mtpa_minerio AS CONTROL
    GLOBAL Text_mtpa_cg AS CONTROL
    GLOBAL Text_max_tbhp AS CONTROL
    GLOBAL Text_max_locos AS CONTROL

    GLOBAL Button_load AS CONTROL
    GLOBAL Button_run AS CONTROL
    GLOBAL Button_exit AS CONTROL
    GLOBAL Button_about AS CONTROL
    GLOBAL Listview1 AS CONTROL
    GLOBAL Progressbar1 AS CONTROL

    GLOBAL FileName$
    CONST  ID_Button_load = 117
    CONST  ID_Button_run  = 118
    CONST  ID_Button_exit = 119
    CONST  ID_Button_about= 120

    '**************************************************************************
    Form1  =            BCX_FORM       ("EFC iron Ore train optimizer",                    235, 101, 380, 430)
    Panel1 =            BCX_CONTROL    ("STATIC"                 , Form1,"Parameters",102,   8,   8, 272, 172, 1342177543, 65568)
    Label1 =            BCX_LABEL      ("Tonn/HP"                ,Panel1,             103,  16,  24,  56,  16)
    Label2 =            BCX_LABEL      ("Locomotives"            ,Panel1,             104,  16,  56,  96,  16)
    Label3 =            BCX_LABEL      ("Vol.Iron ore"           ,Panel1,             105,  16,  88,  72,  16)
    Label4 =            BCX_LABEL      ("Vol.General cargo"      ,Panel1,             106,  16, 120,  72,  16)
    Retorno_menor =     BCX_CHECKBOX   ("Small return"           ,Panel1,             107,  10, 144,  90,  24)
    Rebocadas =         BCX_CHECKBOX   ("Towed locom."           ,Panel1,             108, 105, 144,  80,  24)
    Sem_patio_check =   BCX_CHECKBOX   ("S/novo ptio"           ,Panel1,             124, 185, 144,  85,  24)
    Text_min_tbhp =     BCX_INPUT      ("1.475"                  ,Panel1,             109, 112,  16,  48,  24)
    Text_min_locos =    BCX_INPUT      ("1"                      ,Panel1,             110, 112,  48,  48,  24)
    Text_mtpa_minerio = BCX_INPUT      ("67.2"                   ,Panel1,             111, 112,  80,  48,  24)
    Text_mtpa_cg =      BCX_INPUT      ("5.4"                    ,Panel1,             112, 112, 112,  48,  24)
    Label5 =            BCX_LABEL      ("to"                     ,Panel1,             113, 168,  24,  32,  16)
    Label6 =            BCX_LABEL      ("to"                     ,Panel1,             114, 168,  56,  32,  16)
    Text_max_tbhp =     BCX_INPUT      ("7.146"                  ,Panel1,             115, 200,  16,  48,  24)
    Text_max_locos =    BCX_INPUT      ("6"                      ,Panel1,             116, 200,  48,  48,  24)
    Button_load =       BCX_BUTTON     ("INI File"               , Form1,             117, 288,  32,  72,  24)
    Button_run =        BCX_BUTTON     ("Run"                    , Form1,             118, 288,  64,  72,  24)
    Button_exit =       BCX_BUTTON     ("Exit"                   , Form1,             119, 288,  96,  72,  24)
    Button_about =      BCX_BUTTON     ("About"                  , Form1,             120, 288, 128,  72,  24)
    Listview1 =         BCX_LISTVIEW   ("Listview1"              , Form1,             121,   8, 200, 352, 176)
    Label7 =            BCX_LABEL      ("15 better results:"     , Form1,             122,   8, 184, 200,  16)
    Progressbar1 =      BCX_PROGRESSBAR("Progressbar1"           , Form1,             123,   8, 384, 352,  20, 1342177281, 131072)
    '**************************************************************************

    Set_ColumnText (Listview1,0,"Cost")
    Set_ColumnText (Listview1,1,"Locos")
    Set_ColumnText (Listview1,2,"wagons")
    Set_ColumnText (Listview1,3,"Tonn/HP")
    Set_ColumnText (Listview1,4,"Total locos")
    Set_ColumnText (Listview1,5,"Total wagons")
    Set_ColumnText (Listview1,6,"Extended stations")
    Set_ColumnText (Listview1,7,"New stations")
    Set_ColumnText (Listview1,8,"thousand liters")
    Set_ColumnText (Listview1,9,"crews")

    center(Form1)               'Center the form on screen
    show(Form1)                 'Show the window
END SUB
'---------------------------------------------------------------


BEGIN EVENTS
IF CBCTL = ID_Button_load THEN Button_load_Click()
IF CBCTL = ID_Button_run THEN Button_run_Click()
IF CBCTL = ID_Button_exit THEN CmdExit()
IF CBCTL = ID_Button_about THEN Botao_Sobre_Click()
IF CBMSG = WM_CLOSE THEN CmdExit()
IF CBMSG = WM_DESTROY THEN PostQuitMessage(0)
END EVENTS


'*****************************************
'Execution routines with click of the buttons
'*****************************************

SUB CmdExit
      IF MSGBOX("Its results are in the file SAIDA.CSV","End of simulation ?", 4) = IDYES THEN DestroyWindow(Form1)
END SUB

SUB Botao_Sobre_Click
    DIM Minhamsg$
    Minhamsg$ = "EFC Iron Ore train optimizer"+CRLF$+"17/11/03  -  version 1.00.00"+CRLF$+"Freeware"+CRLF$+CRLF$+"Tito Livio Medeiros Cardoso"
    MSGBOX Minhamsg$,"Sobre",0+64
END SUB

SUB Button_load_Click
  LOCAL Mask$, A$
  Mask$ = "Configuratiuon files(*.ini) |*.INI"
  FileName$ = GETFILENAME$("Load optimization parameters", Mask$)

  IF EXIST(FileName$) then
    OPEN FileName$ FOR INPUT AS Fp1
    WHILE NOT EOF(Fp1)
      LINE INPUT Fp1, A$
      IF INSTR(A$, "MIN TB-HP") then    BCX_SET_TEXT (Text_min_tbhp,    RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
      IF INSTR(A$, "MAX TB-HP") then    BCX_SET_TEXT (Text_max_tbhp,    RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
      IF INSTR(A$, "MIN LOCOS") then    BCX_SET_TEXT (Text_min_locos,   RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
      IF INSTR(A$, "MAX LOCOS") then    BCX_SET_TEXT (Text_max_locos,   RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
      IF INSTR(A$, "MTPA MINERIO") then BCX_SET_TEXT (Text_mtpa_minerio,RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
      IF INSTR(A$, "MTPA CG") then      BCX_SET_TEXT (Text_mtpa_cg,     RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
      IF INSTR(A$, "RETORNO MENOR") then
           SendMessage(Retorno_menor,BM_SETCHECK,BST_CHECKED,0)
           IF VAL(RIGHT$(A$,LEN(A$)-INSTR(A$, ":"))) = 0 then SendMessage(Retorno_menor,BM_SETCHECK,BST_UNCHECKED,0)
      END IF
      IF INSTR(A$, "PERMITE REBOCADAS") then
           SendMessage(Rebocadas,BM_SETCHECK,BST_CHECKED,0)
           IF VAL(RIGHT$(A$,LEN(A$)-INSTR(A$, ":"))) = 0 then SendMessage(Rebocadas,BM_SETCHECK,BST_UNCHECKED,0)
      END IF
      IF INSTR(A$, "SEM NOVOS PATIOS") then
           SendMessage(Sem_patio_check,BM_SETCHECK,BST_CHECKED,0)
           IF VAL(RIGHT$(A$,LEN(A$)-INSTR(A$, ":"))) = 0 then SendMessage(Sem_patio_check,BM_SETCHECK,BST_UNCHECKED,0)
      END IF
      IF INSTR(A$, "ACOPLAGEM DO HELP")    then acopla_help = VAL(RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
      IF INSTR(A$, "ESPERA EM CRUZAMENTO") then espera_cruz = VAL(RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
      IF INSTR(A$, "CUSTO LINHA/METRO")    then custo_linha = VAL(RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
      IF INSTR(A$, "SO TRANSIT TIME")      then chk_terminal= VAL(RIGHT$(A$,LEN(A$)-INSTR(A$, ":")))
    WEND
    CLOSE Fp1
  END IF
END SUB


' ********************
' OPTIMIZATION ROUTINE
' ********************

SUB Button_run_Click

    'Definition of UDTs for use in the variables of the routine
    TYPE myJ
    atual          AS INTEGER
    melhor[16]     AS INTEGER
    locos[16]      AS INTEGER
    vg[16]         AS INTEGER
    tbhp[16]       AS DOUBLE
    locos_tot[16]  AS INTEGER
    gdt[16]        AS INTEGER
    extpatio[16]   AS INTEGER
    novpatio[16]   AS INTEGER
    mil_litros[16] AS INTEGER
    equipes[16]    AS INTEGER
    END TYPE

    TYPE myMTPA
    minerio as DOUBLE
    cg      as DOUBLE
    END TYPE

    TYPE myblocos
    expor   AS INTEGER
    retorno AS INTEGER
    END TYPE

    TYPE myHP
    expor   AS INTEGER
    retorno AS INTEGER
    END TYPE

    TYPE mylocos
    minimo    AS INTEGER
    maximo    AS INTEGER
    expor     AS INTEGER
    expor_ant AS INTEGER
    expor_c36 AS INTEGER
    expor_c44 AS INTEGER
    retorno   AS INTEGER
    END TYPE

    TYPE mytbhp
    minimo  as DOUBLE
    maximo  as DOUBLE
    expor   as DOUBLE
    retorno as DOUBLE
    atual   as DOUBLE
    END TYPE

    TYPE mymarcha
    expor   as DOUBLE
    retorno as DOUBLE
    END TYPE

    TYPE myEE
    expor   as DOUBLE
    retorno as DOUBLE
    END TYPE

    TYPE mylink
    expor   as DOUBLE
    retorno as DOUBLE
    END TYPE

    TYPE myciclo
        loco  AS DOUBLE
        vagao AS DOUBLE
    END TYPE

    TYPE myTPM
        loco  AS DOUBLE
        vagao AS DOUBLE
    END TYPE

    TYPE mytrem_dia
    expor    as DOUBLE
    retorno  as DOUBLE
    cg_expor AS DOUBLE
    END TYPE

    TYPE myR
    C36   as DOUBLE
    C44   as DOUBLE
    serie AS DOUBLE
    trem  AS DOUBLE
    END TYPE

    TYPE myTB
    expor   AS INTEGER
    retorno AS INTEGER
    END TYPE

    TYPE myVG
    expor     AS INTEGER
    expor_ant AS INTEGER
    retorno   AS INTEGER
    END TYPE

    TYPE myMKBF
    C36     AS INTEGER
    C44     AS INTEGER
    END TYPE

    TYPE mynecess
    locos    AS INTEGER
    GDT      AS INTEGER
    patios   AS INTEGER
    diesel   AS INTEGER
    equipes  AS INTEGER
    locotrol AS INTEGER
    END TYPE

    'Definition of UDT in head office with the characteristics of each group of allocated help
    TYPE myhelp
    HP    [7] AS DOUBLE
    C44   [7] AS DOUBLE
    ciclo [7] AS DOUBLE
    necess    AS DOUBLE
    END TYPE


    CONST frota_locos         = 59
    CONST frota_GDT           = 3986
    CONST inv_loco_minerio    = 1800
    CONST inv_loco_cg         = 600
    CONST vida_loco           = 10  'Tie the first full overhaul
    CONST vida_vg             = 40
    CONST cap_virador         = 120
    CONST nr_virador          = 2
    CONST passo_tbhp          = 0.001
    CONST ET_adm              = 170
    CONST ET_vida_infinita    = 60
    CONST ET_AS_IS            = 88
    CONST FrotaC36_FrotaTotal = 0.8 '(39 C36 + 2 SD60) e (14 C44 + 4 C40): Total 59 locos
    CONST tb_vg_expor         = 122
    CONST tu_vg_expor         = 102
    CONST tb_vg_retorno       = 20
    CONST tu_trem_cg          = 4500
    CONST dias_ano            = 355
    CONST dias_ano_cg         = 355
    CONST sigma_c36           = 47871
    CONST sigma_c44           = 53259
    CONST R_AS_IS             = 0.798
    CONST DMSB                = 5
    CONST l_vagao             = 10
    CONST l_loco              = 22
    CONST ext_seguranca       = 20
    CONST dist_marco_amv      = 250  'total of the two extremities of the station
    CONST cte_colson          = 0.75
    CONST indisp_via          = 2
    CONST outros_trens_dia    = 1    '(0.5 passengers train + 0.5 service)
    CONST indisp_loco         = 0.78
    CONST indisp_vg           = 0.98

    DIM custo_loco            as INTEGER
    DIM permite_retorno_menor as BOOLEAN
    DIM permite_rebocadas     as BOOLEAN
    DIM sem_patio             as BOOLEAN
    DIM reb                   as INTEGER
    DIM tamanho_retorno       AS INTEGER
    DIM tamanho_novo_patio    AS INTEGER
    DIM andamento             as INTEGER
    DIM inicio                AS SINGLE
    DIM final                 AS SINGLE
    DIM elapsed               AS SINGLE
    DIM k                     AS Integer
    DIM k1                    AS Integer
    DIM k2                    AS DOUBLE
    DIM ITER                  AS Integer
    DIM total_ITER            AS Integer
    DIM tr_falta_cap          AS Integer
    DIM nr_helps              AS Integer
    DIM rampa                 AS DOUBLE
    DIM ET                    AS DOUBLE
    DIM trem_malha_expor      AS DOUBLE
    DIM avaria                AS DOUBLE
    DIM quebra                AS DOUBLE
    DIM tmp_help              AS DOUBLE
    DIM cruzamento            AS DOUBLE
    DIM tmp_cruz              AS DOUBLE
    DIM headway               AS DOUBLE
    DIM PA                    AS DOUBLE
    DIM CKS                   AS DOUBLE
    DIM TT_expor              AS DOUBLE
    DIM sobra                 AS INTEGER
    DIM extensao_patios       AS INTEGER
    DIM patios_a_ampliar      AS STRING
    DIM nr_patios_a_ampliar   AS INTEGER
    DIM par_trem_dia          AS DOUBLE
    DIM cap_pares_trem        AS DOUBLE
    DIM novos_patios          AS INTEGER
    DIM patios_a_construir    AS STRING
    DIM mymsg$

    DIM J        AS myJ
    DIM MTPA     AS myMTPA
    DIM blocos   AS myblocos
    DIM HP       AS myHP
    DIM locos    AS mylocos
    DIM tbhp     AS mytbhp
    DIM marcha   AS mymarcha
    DIM EE       AS myEE
    DIM link     AS mylink
    DIM ciclo    AS myciclo
    DIM TPM      AS myTPM
    DIM trem_dia AS mytrem_dia
    DIM R        AS myR
    DIM TB       AS myTB
    DIM VG       AS myVG
    DIM MKBF     AS myMKBF
    DIM necess   AS mynecess
    DIM help     AS myhelp

    'Definition of head offices of the characteristics of the critical spaces of EFC
    SET tbhp_inferior#[]
    0.000,  2.806,  3.632,  3.667,  3.701,  3.977,  4.080,  4.976,  5.010,  5.527,  6.801,  6.973
    END SET
    SET tbhp_superior#[]
    2.806,  3.632,  3.667,  3.701,  3.977,  4.080,  4.976,  5.010,  5.527,  6.801,  6.973,  7.200
    END SET
    SET trechos_falta_cap%[]
    0,      1,      2,      3,      4,      5,      7,      8,      9,     11,     12,     13
    END SET
    SET trechos_nr_helps%[]
    0,      1,      2,      3,      3,      4,      4,      4,      5,      6,      6,      6
    END SET
    SET ciclo_help#[]
    0.00, 7.80, 0.66, 0.48, 4.08, 1.32, 5.40, 9.00, 10.50, 0.36, 0.42, 10.50, 1.56, 6.00
    END SET
    SET trechos_rampa#[]
    0.0037, 0.0037, 0.0027, 0.0026, 0.0026, 0.0024, 0.0023, 0.0018, 0.0018, 0.0017, 0.0015, 0.0012, 0.0008
    END SET

    'Definition of head offices of the characteristics of the built stations of EFC
    SET locacao$[]       '47
    "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21",
    "23", "24", "25", "26", "27", "28", "30", "31", "33", "34", "36", "38", "39", "41", "42", "43", "44", "45", "46",
    "47", "48", "49", "50", "51", "53", "54", "56"
    END SET
    SET CTU%[]
    2496, 2769, 2482, 2296, 2302, 2263, 2300, 2303, 2254, 2298, 2306, 2301, 2359, 2307, 2302, 2267, 2299, 2296, 2305,
    2273, 2304, 2300, 3217, 2224, 2781, 2298, 3468, 2303, 2299, 2312, 2299, 2171, 2296, 2301, 2500, 2263, 2299, 2295,
    2299, 2282, 3026, 2307, 2293, 2300, 2176, 2302, 3103
    END SET

    'Definition of head offices of the characteristics of the 48 spaces among equal of built stations of EFC
    SET par$[]
    "1-2",    "2-3",  "3-4",  "4-5",  "5-6",  "6-7",  "7-8",  "8-9",  "9-10","10-11","11-12","12-13","13-14","14-15","15-16",
    "16-17","17-18","18-19","19-20","20-21","21-23","23-24","24-25","25-26","26-27","27-28","28-30","30-31",
    "31-33","33-34","34-36","36-38","38-39","39-41","41-42","42-43","43-44","44-45","45-46","46-47","47-48",
    "48-49","49-50","50-51","51-53","53-54","54-56","56-58",""
    END SET
    SET Headway_espor#[]
    0.018, 0.015, 0.012, 0.014, 0.014, 0.019, 0.016, 0.015, 0.015, 0.013, 0.014, 0.016, 0.032, 0.021, 0.015, 0.013, 0.013, 0.013, 0.013, 0.014, 0.024, 0.013, 0.016, 0.012, 0.013,
    0.013, 0.023, 0.031, 0.061, 0.021, 0.042, 0.048, 0.022, 0.067, 0.024, 0.016, 0.016, 0.014, 0.018, 0.015, 0.041, 0.018, 0.014, 0.014, 0.025, 0.018, 0.023, 0.021
    END SET
    SET Headway_retorno#[]
    0.013, 0.011, 0.015, 0.018, 0.018, 0.016, 0.016, 0.017, 0.019, 0.046, 0.017, 0.016, 0.017, 0.016, 0.018, 0.015, 0.015, 0.018, 0.015, 0.019, 0.032, 0.047, 0.021, 0.023, 0.026,
    0.024, 0.025, 0.011, 0.018, 0.021, 0.026, 0.016, 0.015, 0.023, 0.014, 0.016, 0.018, 0.047, 0.016, 0.017, 0.022, 0.015, 0.017, 0.016, 0.034, 0.013, 0.029, 0.042
    END SET

    'values default for some varied in case has not had input in the INI file
    IF acopla_help = 0 then acopla_help = 0.25
    IF espera_cruz = 0 then espera_cruz = 0.02
    IF custo_linha = 0 then custo_linha = 0.213

    '### recovers the variables defined in the form ###
    tbhp.minimo      = VAL( BCX_Get_Text$ (Text_min_tbhp)    )
    tbhp.maximo      = VAL( BCX_Get_Text$ (Text_max_tbhp)    )
    locos.minimo     = VAL( BCX_Get_Text$ (Text_min_locos)   )
    locos.maximo     = VAL( BCX_Get_Text$ (Text_max_locos)   )
    MTPA.minerio     = VAL( BCX_Get_Text$ (Text_mtpa_minerio))
    MTPA.cg          = VAL( BCX_Get_Text$ (Text_mtpa_cg)     )

    'User is verified he wants to calculate with smaller return
    permite_retorno_menor = FALSE
    k=SendMessage(Retorno_menor,BM_GETCHECK,0,0)
    IF k=BST_CHECKED THEN permite_retorno_menor = TRUE

    'User is verified he wants to calculate with having towed locomotives
    permite_rebocadas = FALSE
    k=SendMessage(Rebocadas,BM_GETCHECK,0,0)
    IF k=BST_CHECKED THEN permite_rebocadas = TRUE

    'User is verified he wants to calculate without additional stations
    sem_patio = FALSE
    k=SendMessage(Sem_patio_check,BM_GETCHECK,0,0)
    IF k=BST_CHECKED THEN sem_patio = TRUE

    'defines the maximum number of calculations to accomplish
    total_ITER   = (locos.maximo-locos.minimo+1) * INT((tbhp.maximo-tbhp.minimo)/passo_tbhp)

    'initializes accountants and the progress bar
    J.melhor[0] = 1000000000
    inicio      = TIMER
    ITER        = 0
    andamento   = 0
    SendMessage(Progressbar1,PBM_SETPOS,andamento,0)
    BCX_LV_Reset ( Listview1, 10, 15 )     'reset 10 coluns and 15 rows of ListView

    'Create/open file for calculation output
    OPEN "saida.csv" FOR OUTPUT  AS fp1
    FWRITE fp1, "locos.expor","HP.expor","expor_c36","expor_c44","towed","wagons.expor","Tonn.expor","tonn/hp.expor","blocks.expor","spaces_without_capacity","number_helps","help[1]","help[2]","help[3]","help[4]","help[5]","help[6]","help.cycle[1]","help.cycle[2]","help.cycle[3]","help.cycle[4]","help.cycle[5]","help.cycle[6]","locos for help","Ramp(%)","Tractor effort(ton)","locos.return","HP.return","Wagons.return","Tonn.return","tonn/hp.return","blocks.return","metrage_return","MKBF.C36","MKBF.C44","reliability.C36","reliability.C44","reliability.train","train/day.expor","train/day.return","Running time.expor","Running time.return","Failure","train division","coupling help","PA","Carajas","Ponta da Madeira Terminal.wagon","Ponta da Madeira Terminal.locos","crossing","cycle.wagon","cycle.locos","L/ktkb.expor","L/ktkb.return","nr.extended stations","extended stations name","new stations","spaces for new stations","Total locos","Total wagons","metrage stations","diesel(1000L)","crews","locotrol","J-Cost"
    CLOSE fp1


    'CALCULATION LOOPING FOR LOCOS AND TONN-HP
    FOR locos.expor = locos.minimo TO locos.maximo
        locos.expor_c36 = ROUND(FrotaC36_FrotaTotal * locos.expor, 0)
        locos.expor_c44 = locos.expor - locos.expor_c36
        HP.expor        = 3600*locos.expor_c36 + 4400*locos.expor_c44

        FOR tbhp.atual = tbhp.minimo TO tbhp.maximo STEP passo_tbhp

            ITER = ITER + 1
            SetWindowText(Form1,("Processando " + USING$("#", 100 * ITER/total_ITER) + "%"))

            TB.expor          = tbhp.atual * HP.expor
            VG.expor          = (TB.expor - 180 * locos.expor) / tb_vg_expor
            TB.expor          = VG.expor*tb_vg_expor +  180*locos.expor
            tbhp.expor        = CDBL(TB.expor) / CDBL(HP.expor)
            IF locos.expor=locos.expor_ant AND VG.expor=VG.expor_ant then GOTO nova_tentativa

            reb = 0
            IF permite_rebocadas = TRUE then reb = 1

            FOR k=0 to 11
                IF  tbhp.expor  >= tbhp_inferior#[k] AND tbhp.expor < tbhp_superior#[k] then
                    tr_falta_cap = trechos_falta_cap%[k]
                    nr_helps     = trechos_nr_helps%[k]
                    rampa        = trechos_rampa#[k+1]
                    EXIT FOR
                END IF
            NEXT 'k

            ET              = locos.expor * (2.59 + 3600.209*rampa) * tbhp.expor
            IF  (ET/ET_adm) > CDBL(locos.expor/2) then
               blocos.expor = ARRED_PARA_CIMA(ET/ET_adm)
            ELSE
               blocos.expor = ARRED_PARA_CIMA( CDBL(locos.expor)/2 )
            END IF
            IF blocos.expor > 3 then GOTO nova_tentativa
            ET              = ARRED_PARA_CIMA(locos.expor/blocos.expor)*(2.59+3600.209*rampa)*tbhp.expor

            VG.retorno      = VG.expor
            IF VG.expor>206 AND permite_retorno_menor=TRUE then VG.retorno=206
            locos.retorno   = INT((locos.expor+reb)*(VG.retorno/VG.expor))  'probable locos number in the return for the swinging
            IF locos.retorno= 0 then locos.retorno = 1
            TB.retorno      = VG.retorno*tb_vg_retorno +  180*locos.retorno
            k               = ROUND( FrotaC36_FrotaTotal * locos.retorno, 0)
            k1              = locos.retorno - k
            HP.retorno      = 3600*k + 4400*k1
            tbhp.retorno    = CDBL(TB.retorno) / CDBL(HP.retorno)
            tamanho_retorno = l_vagao*VG.retorno + l_loco*locos.retorno

            FOR k=0 to 6
                    help.HP   [k]=0
                    help.C44  [k]=0
                    help.ciclo[k]=0
            NEXT 'k
            IF nr_helps > 0 then
                FOR k=0 to 11
                    IF trechos_nr_helps%[k] > nr_helps then EXIT FOR
                    help.HP[trechos_nr_helps%[k]]    = 1.2*TB.expor/tbhp_inferior#[k] - HP.expor
                    help.C44 [trechos_nr_helps%[k]]  = POSITIVO(ARRED_PARA_CIMA(help.HP[trechos_nr_helps%[k]]/4400) - reb)
                    IF help.C44[trechos_nr_helps%[k]]> 2 then GOTO nova_tentativa
                NEXT 'k
                'This condition respects the fact that the help 1 already exists formed by 2 C44
                IF help.C44[1]=1 then help.C44[1]=2
            END IF
            help.necess = 0
            FOR k=0 to nr_helps
                k2=ciclo_help#[k]
                IF k=1 AND tr_falta_cap =7                      then k2=ciclo_help#[7]
                IF k=1 AND tr_falta_cap>=8  AND tr_falta_cap<11 then k2=ciclo_help#[8]
                IF k=1 AND tr_falta_cap>=11                     then k2=ciclo_help#[11]
                IF k=3 AND tr_falta_cap>=4  AND tr_falta_cap<6  then k2=ciclo_help#[4]
                IF k=3 AND tr_falta_cap>=6  AND tr_falta_cap<13 then k2=ciclo_help#[6]
                IF k=3 AND tr_falta_cap =13                     then k2=ciclo_help#[13]
                IF k=4                                          then k2=ciclo_help#[5]
                IF k=5                                          then k2=ciclo_help#[9]
                IF k=6 AND tr_falta_cap <12                     then k2=ciclo_help#[10]
                IF k=6 AND tr_falta_cap>=12                     then k2=ciclo_help#[12]
                help.necess  = help.necess + help.C44[k] * k2/24
                help.ciclo[k]= k2
            NEXT 'k

            MKBF.C36         = (1.7813 - 0.1512 * tbhp.expor) * sigma_c36
            MKBF.C44         = (1.7813 - 0.1512 * tbhp.expor) * sigma_c44
            R.C36            = EXP(-1964/ CDBL(MKBF.C36) )^3.42
            R.C44            = EXP(-1964/ CDBL(MKBF.C44) )^3.42
            R.serie          = R.C36^locos.expor_c36 * R.C44^locos.expor_c44
            R.trem           = R.serie
            IF reb>0 then R.trem = 1 - (1-R.serie)*(1-R.C36)

            IF blocos.expor  > 1 then
                 link.expor  = 0.667 + 0.333 * (blocos.expor - 2)
            ELSE
                 link.expor  = 0
            END IF
            blocos.retorno   = blocos.expor
            IF VG.retorno   <= 206 then blocos.retorno = 1
            IF blocos.retorno> 1 then
                 link.retorno= 0.667 + 0.333 * (blocos.retorno - 2)
            ELSE
                 link.retorno= 0
            END IF

            trem_dia.expor   = 1000000 * CDBL(MTPA.minerio) / CDBL(dias_ano * VG.expor * tu_vg_expor)
            trem_dia.retorno = trem_dia.expor * CDBL(VG.expor) / CDBL(VG.retorno)
            trem_dia.cg_expor= 1000000 * MTPA.cg / ( dias_ano_cg * tu_trem_cg )

            marcha.expor     = 12.322202 + 2.7582081 * tbhp.expor   + 0.087699281 * tbhp.expor  ^2
            marcha.retorno   = 13.377    + 0.2138    * tbhp.retorno + 5.8911      * tbhp.retorno^2
            avaria           = 1.08 * ( 1-R.trem ) / ( 1-R_AS_IS )
            quebra           = 0.16 * ( ET / ET_AS_IS )^10.762
            IF ET < ET_vida_infinita then quebra=0
            tmp_help         = (acopla_help * nr_helps) - 0.25

            IF VG.expor>VG.retorno then
            PA               = 1 + (VG.expor/VG.retorno) * (24/trem_dia.retorno) + link.expor
            ELSE
            PA               = 0
            END IF

            CKS              = (1-chk_terminal) * ( 3.367 + 0.004369 * VG.expor )
            TPM.vagao        = (1-chk_terminal) * ( (1.376*VG.retorno/206)+( 2.22*VG.expor/206)+0.847+1.939*ARRED_PARA_CIMA(CDBL(VG.expor)/CDBL(cap_virador)/CDBL(nr_virador))+link.retorno+0.495 )
            TPM.loco         = (1-chk_terminal) * ( (1.376*VG.retorno/206)+(1.024*VG.expor/206)+link.retorno+2.541 )

            patios_a_ampliar = ""
            nr_patios_a_ampliar = 0
            extensao_patios  = 0
            k1 = (2*DMSB) + tamanho_retorno + ext_seguranca
            FOR k=0 to 46
                'The definition of the surplus in station and for the return train since and him that for in the deviation.
                sobra        = CTU%[k] - k1
                IF sobra < 0 then
                    nr_patios_a_ampliar = nr_patios_a_ampliar + 1
                    extensao_patios     = extensao_patios  + ABS(sobra)
                    patios_a_ampliar    = patios_a_ampliar + locacao$[k] + STR$(sobra) + "m "
                END IF
            NEXT 'k

            TT_expor         = marcha.expor + quebra + tmp_help + avaria/2  'As is transit time in the sense export, for premise not for in crossing
            trem_malha_expor = trem_dia.expor * TT_expor/24  'Just trains in the line. It doesn't include time in the terminals.

            patios_a_construir = ""
            novos_patios = 0
            tamanho_novo_patio = 2*DMSB + tamanho_retorno + ext_seguranca + dist_marco_amv
            par_trem_dia = (trem_dia.expor + trem_dia.retorno)/2 + trem_dia.cg_expor + outros_trens_dia
            k2 = cte_colson * (24 - indisp_via)
            tmp_cruz = espera_cruz
            FOR k=0 to 47
                headway = (Headway_espor#[k] * marcha.expor) + (Headway_retorno#[k] * marcha.retorno)
                cap_pares_trem = k2 / headway
                IF  cap_pares_trem < par_trem_dia then
                    IF sem_patio = FALSE then
                                   novos_patios       = novos_patios + 1
                                   patios_a_construir = patios_a_construir + par$[k] + " "
                    ELSE
                                   tmp_cruz = tmp_cruz + (par_trem_dia/cap_pares_trem) * headway/48
                    END IF
                END IF
            NEXT 'k

            cruzamento     = tmp_cruz * (1 + trem_malha_expor + trem_dia.cg_expor )
            ciclo.vagao    = marcha.expor + marcha.retorno + avaria + quebra + cruzamento + tmp_help + PA + CKS + TPM.vagao
            ciclo.loco     = marcha.expor + marcha.retorno + avaria + quebra + cruzamento + tmp_help + PA + CKS + TPM.loco

            EE.expor       = 1.468138 - 0.88124405 * EXP (-34.016473   * tbhp.expor ^ (-3.2662424))
            EE.retorno     = 4.2284   + 0.2711 * tbhp.retorno - 1.1088 * tbhp.retorno ^ 2

            help.necess    = ARRED_PARA_CIMA(trem_dia.expor * help.necess/indisp_loco)
            necess.locos   = trem_dia.expor * ((locos.expor+reb) * ciclo.loco/24)/indisp_loco + help.necess
            necess.GDT     = (trem_dia.expor * VG.expor * ciclo.vagao/24)/indisp_vg
            necess.patios  = extensao_patios + novos_patios * tamanho_novo_patio
            necess.diesel  = INT(0.982*dias_ano/1000 * ( (EE.expor*TB.expor*trem_dia.expor) + (EE.retorno*TB.retorno*trem_dia.retorno) ))
            necess.equipes = 4 * (trem_dia.retorno + trem_dia.retorno)/2 * ciclo.loco/24
            necess.locotrol= 0
            IF blocos.expor>1 then necess.locotrol= INT(1.3 * trem_dia.expor * blocos.expor * ciclo.loco/24)

            k1= necess.GDT   - frota_GDT
            k = necess.locos - frota_locos
            IF k > 0 then
                         custo_loco = inv_loco_minerio
            ELSE
                         custo_loco = inv_loco_cg
            END IF

            J.atual = (custo_loco*k + inv_loco_minerio*MIN(frota_locos,necess.locos)/vida_loco) + 50*(POSITIVO(k1)+MIN(frota_GDT,necess.GDT)/vida_vg) + custo_linha*necess.patios + 0.3229*necess.diesel + 13.56*necess.equipes + 100*necess.locotrol

            IF J.atual <= J.melhor[0] then
                'ROUTINE TO STORE THE 15 BETTER RESULTS
                FOR k = 14 to 0 STEP -1 'linhas
                    J.melhor[k+1]    = J.melhor[k]
                    J.locos[k+1]     = J.locos[k]
                    J.vg[k+1]        = J.vg[k]
                    J.tbhp[k+1]      = J.tbhp[k]
                    J.locos_tot[k+1] = J.locos_tot[k]
                    J.gdt[k+1]       = J.gdt[k]
                    J.extpatio[k+1]  = J.extpatio[k]
                    J.novpatio[k+1]  = J.novpatio[k]
                    J.mil_litros[k+1]= J.mil_litros[k]
                    J.equipes[k+1]   = J.equipes[k]
                NEXT 'k
                    J.melhor[0]      = J.atual
                    J.locos[0]       = locos.expor
                    J.vg[0]          = VG.expor
                    J.tbhp[0]        = tbhp.expor
                    J.locos_tot[0]   = necess.locos
                    J.gdt[0]         = necess.GDT
                    J.extpatio[0]    = nr_patios_a_ampliar
                    J.novpatio[0]    = novos_patios
                    J.mil_litros[0]  = necess.diesel
                    J.equipes[0]     = necess.equipes
            END IF
            'It modernizes ListView with the new great value
            FOR k = 0 to 14
                ListView_SetItemText ( Listview1, k, 0,  str$(J.melhor[k])      )
                ListView_SetItemText ( Listview1, k, 1,  str$(J.locos[k])       )
                ListView_SetItemText ( Listview1, k, 2,  str$(J.vg[k])          )
                ListView_SetItemText ( Listview1, k, 3,using$("#.###",J.tbhp[k]))
                ListView_SetItemText ( Listview1, k, 4,  str$(J.locos_tot[k])   )
                ListView_SetItemText ( Listview1, k, 5,  str$(J.gdt[k])         )
                ListView_SetItemText ( Listview1, k, 6,  str$(J.extpatio[k])    )
                ListView_SetItemText ( Listview1, k, 7,  str$(J.novpatio[k])    )
                ListView_SetItemText ( Listview1, k, 8,  str$(J.mil_litros[k])  )
                ListView_SetItemText ( Listview1, k, 9,  str$(J.equipes[k])     )
            NEXT 'k

            'ROUTINE to RECORD THE VALUES IN CSV FILE AND to EXHIBIT THE LAST ones IN LISTVIEW
            OPEN "saida.csv" FOR APPEND  AS fp1
            FWRITE fp1, str$(locos.expor),str$(HP.expor),str$(locos.expor_c36),str$(locos.expor_c44),str$(reb),str$(VG.expor),str$(TB.expor),using$("#.###",tbhp.expor),str$(blocos.expor),str$(tr_falta_cap),str$(nr_helps),str$(help.C44[1]),str$(help.C44[2]),str$(help.C44[3]),str$(help.C44[4]),str$(help.C44[5]),str$(help.C44[6]),str$(help.ciclo[1]),str$(help.ciclo[2]),str$(help.ciclo[3]),str$(help.ciclo[4]),str$(help.ciclo[5]),str$(help.ciclo[6]),str$(help.necess),using$("#.###",100*rampa),using$("#.#",ET),str$(locos.retorno),str$(HP.retorno),str$(VG.retorno),str$(TB.retorno),using$("#.###",tbhp.retorno),str$(blocos.retorno),str$(tamanho_retorno),str$(MKBF.C36),str$(MKBF.C44),using$("#.###",R.C36),using$("#.###",R.C44),using$("#.###",R.trem),using$("#.#",trem_dia.expor),using$("#.#",trem_dia.retorno),using$("#.##",marcha.expor),using$("#.##",marcha.retorno),using$("#.##",avaria),using$("#.##",quebra),using$("#.##",tmp_help),using$("#.##",PA),using$("#.##",CKS),using$("#.##",TPM.vagao),using$("#.##",TPM.loco),using$("#.##",cruzamento),using$("#.##",ciclo.vagao),using$("#.##",ciclo.loco),using$("#.###",EE.expor),using$("#.###",EE.retorno),str$(nr_patios_a_ampliar),patios_a_ampliar,str$(novos_patios),patios_a_construir,str$(necess.locos),str$(necess.GDT),str$(necess.patios),str$(necess.diesel),str$(necess.equipes),str$(necess.locotrol),str$(J.atual)
            CLOSE fp1

nova_tentativa:

            locos.expor_ant = locos.expor
            VG.expor_ant    = VG.expor
            andamento = INT(100 * ITER/total_ITER)
            SendMessage(Progressbar1,PBM_SETPOS,andamento,0)
        NEXT 'tbhp.atual
    NEXT 'locos.expor

    'Create/openm file for 15 better solutions output
    OPEN "sol.csv" FOR OUTPUT  AS  FP1
    FWRITE fp1, "J","loc/trem","vg","tb/hp","locos.total.trem","GDT","Ext.patio","Novo patio","mil L","equipes"
    FOR k=0 to 14
        FWRITE fp1, str$(J.melhor[k]),str$(J.locos[k]),str$(J.vg[k]),str$(J.tbhp[k]),str$(J.locos_tot[k]),str$(J.gdt[k]),str$(J.extpatio[k]),str$(J.novpatio[k]),str$(J.mil_litros[k]),str$(J.equipes[k])
        NEXT 'k
    CLOSE FP1

    FOR k = 0 TO 10
      SendMessage (Listview1, LVM_SETCOLUMNWIDTH, k, LVSCW_AUTOSIZE_USEHEADER)
    NEXT

    final   = TIMER
    elapsed = final - inicio
    mymsg$  = "Clculo completado em "+ using$("##.#",elapsed) + "seg" + CRLF$ + "Total RUNs: " + str$(total_ITER)
    MSGBOX mymsg$,"FIM",0

    SetWindowText( Form1,"Otimizador do trem de minrio da EFC" )

END SUB



' ***************************
' FUNCTIONS AND ROUTINES OF SUPPORT
' ***************************

FUNCTION POSITIVO (N AS INTEGER) AS INTEGER
'This function return zero comes back if negative or the own number if positive'
    IF N < 0 then
                 FUNCTION = 0
    ELSE
                 FUNCTION = N
    END IF
END FUNCTION

FUNCTION ARRED_PARA_CIMA (N AS DOUBLE) AS INTEGER
'This function rounds above for integer
    IF MOD( (1+N), INT(1+N) ) = 0 then
                   FUNCTION = INT(N)
    ELSE
                   FUNCTION = INT(N + 1)
    END IF
END FUNCTION

SUB Set_ColumnText (hWnd AS HWND, Column, Text$)
    LOCAL lvc AS LV_COLUMN
    lvc.mask = LVCF_TEXT
    lvc.pszText = Text$
    SendMessage(hWnd, LVM_SETCOLUMN, Column, &lvc)
    SendMessage (Listview1, LVM_SETCOLUMNWIDTH, Column, LVSCW_AUTOSIZE_USEHEADER)
END SUB

SUB BCX_LV_Reset ( LView AS CONTROL, Columns, Rows )
    LOCAL lvItem AS LV_ITEM
    LOCAL i
    ListView_DeleteAllItems (LView)
    REPEAT Rows
    lvItem.mask      =  LVIF_TEXT
    lvItem.pszText   =  " "
    lvItem.iSubItem  =  0
    ListView_InsertItem(Listview1, &lvItem)
    END REPEAT
END SUB

SUB BCX_LV_Justify ( LV as HANDLE,Column, JustifyType )
    LOCAL hHeader AS LONG
    LOCAL hdi As HD_ITEM
    '--------------------------------------
    CONST HDF_LEFT      = 0    'JustifyType
    CONST HDF_RIGHT     = 1    'JustifyType
    CONST HDF_CENTER    = 2    'JustifyType
    '--------------------------------------
    CONST LVM_FIRST     = 4096
    CONST LVM_GETHEADER = LVM_FIRST + 31
    '--------------------------------------
    hHeader     = SendMessage(LV, LVM_GETHEADER, 0, 0)
    hdi.mask    = HDI_FORMAT
    hdi.pszText = " "
    hdi.fmt     = HDF_STRING Or JustifyType
    SendMessage ((HWND)hHeader, HDM_SETITEM, Column, &hdi)
END SUB
